;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;SMW Thwomp
;;
;;This is a disassembly of sprite 26 in SMW - Thwomp
;;
;;Comes with On/Off and mini versions (by yoshicookiezeus)
;;
;;Extra Property Byte 1 - Yes
;;
;;Any non-zero value - mini version (it'll look like thwimp)
;;
;;Extra Bit - yes
;;
;;If set, it's movement will depend on On/Off state.
;;
;;By RussianMan. Credit is optional.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tilemap:
        db $8E,$8E,$AE,$AE,$C8

!angry_tile     = $CA

;-

!sfx            = $09
!sfx_bank       = $1DFC|!Base2

!y_speed_peak   = $3E
!y_speed_add    = $04

!shake_time     = $18

;---

print "INIT ",pc
        LDA !E4,x
        CLC
        ADC #$08
        STA !E4,x
        RTL

print "MAIN ",pc
        PHB
        PHK
        PLB
        JSR shatter_thwomp
        PLB
        RTL

;---

shatter_thwomp:
        JSR draw_sprite
        LDA !14C8,x
        EOR #$08
        ORA $9D
        BNE .return
        %SubOffScreen()
        JSL $01A7DC|!BankB
        LDA !C2,x
        BNE .falling

;-

.still
        LDA !15A0,x
        ORA !186C,x
        BNE .return
        %SubHorzPos()
        STZ !1528,x
        ; LDA $0F
        ; BNE .return
        LDA $0E
        CLC
        ADC #$40
        CMP #$80
        BCS +
        INC !1528,x
+       LDA $0E
        ADC #$24
        CMP #$50
        BCS .return

.offscreen
        LDA #$02
        STA !1528,x
        INC !C2,x
        STZ !AA,x
.return
        RTS

;-

.falling
        JSL $01801A|!BankB
        LDA !AA,x
        CMP #!y_speed_peak
        BCS +
        ADC #!y_speed_add
        STA !AA,x
+       JSL $019138|!BankB
        LDA !1588,x
        AND #$04
        BEQ .return
        LDA !1588,x
        BMI +
        LDA #$00
        LDY !15B8,x
        BEQ .store
+       LDA #$18
.store
        STA !AA,x
        LDA #!shake_time
        STA $1887|!Base2

        LDA #!sfx
        STA !sfx_bank

        STZ !14C8,x
        PEA.w ($02)|(shatter_thwomp>>16<<8)
        PLB
        LDA !D8,x
        CLC
        ADC #$10
        STA $98
        LDA !14D4,x
        ADC #$00
        STA $99
        LDA !E4,x
        STA $9A
        LDA !14E0,x
        STA $9B
        JSL $028663|!BankB
        PLB

        LDY #$01
-       PHY
        LDA spawn_x_disp,y
        STA $00
        LDA #$10
        STA $01
        STZ $02
        STZ $03
        LDA #$27
        CLC
        %SpawnSprite()
        BCS .return
        LDA $01,s
        BEQ +
        LDA #$01
        STA.w !C2,y
+       PLY
        DEY
        BPL -
        RTS

spawn_x_disp:
        db $F4,$0C

;---

props:
        db $03,$43,$03,$43,$03
x_disp:
        db $FC,$04,$FC,$04,$00
y_disp:
        db $00,$00,$10,$10,$08

draw_sprite:
%GetDrawInfo()
        LDA !1528,x
        STA $02
        LDX #$03
        CMP #$00
        BEQ .loop
        INX
.loop
        LDA $00
        CLC
        ADC x_disp,x
        STA $0300|!Base2,y

        LDA $01
        CLC
        ADC y_disp,x
        STA $0301|!Base2,y

        LDA props,x
        ORA $64
        STA $0303|!Base2,y

        LDA tilemap,x
        CPX #$04
        BNE .store
        PHX
        LDX $02
        CPX #$02
        BNE +
        LDA #!angry_tile
+       PLX
.store
        STA $0302|!Base2,y
        INY #4
        DEX
        BPL .loop

        LDX $15E9|!Base2
        LDY #$02
        LDA #$04
        JSL $01B7B3|!BankB
        RTS

